import {ProductGamesystem} from "../../../../src/app/game-model/gamesystems/ProductGamesystem";
import {SimpleGamesystem} from "../../../../src/app/game-model/gamesystems/SimpleGamesystem";

export class ProductSystemGenerationTrainer {

  static PRODUCTGAMESYSTEMNAME = "ProductGamesystem";
  static CHILDGAMESYSTEMNAME_LEFT = "Left Child System";
  static CHILDGAMESYSTEMNAME_RIGHT = "Right Child System";

  static LEFTCHILDSYSTEM_A_NODE_NAME = "A";
  static LEFTCHILDSYSTEM_B_NODE_NAME = "B";

  static RIGHTCHILDSYSTEM_A_NODE_NAME = "1";
  static RIGHTCHILDSYSTEM_B_NODE_NAME = "2";
  static givenSimplestProductSystem() {
    const productsystem = new ProductGamesystem(ProductSystemGenerationTrainer.PRODUCTGAMESYSTEMNAME);
    const left_childsystem = new SimpleGamesystem(ProductSystemGenerationTrainer.CHILDGAMESYSTEMNAME_LEFT);
    const right_childsystem = new SimpleGamesystem(ProductSystemGenerationTrainer.CHILDGAMESYSTEMNAME_RIGHT);

    left_childsystem.createTransition(left_childsystem.createState(ProductSystemGenerationTrainer.LEFTCHILDSYSTEM_A_NODE_NAME, "")!,
                                      left_childsystem.createState(ProductSystemGenerationTrainer.LEFTCHILDSYSTEM_B_NODE_NAME, "")!);
    right_childsystem.createTransition(right_childsystem.createState(ProductSystemGenerationTrainer.RIGHTCHILDSYSTEM_A_NODE_NAME, "")!,
                                      right_childsystem.createState(ProductSystemGenerationTrainer.RIGHTCHILDSYSTEM_B_NODE_NAME, "")!);
    productsystem.addChildGamesystem(left_childsystem);
    productsystem.addChildGamesystem(right_childsystem);

    return productsystem;
  }
}
